#ifndef opt_cddoc_included
#define opt_cddoc_included

/*** Qt ***/
#include <qlineedit.h>
#include <qdialog.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>

/*** KDE ***/
#include <ksimpleconfig.h>
#include <kapp.h>

/*** C++ ***/
#include <string>
#include <iostream.h>

/*** KisoCD ***/
#include "tools.h"
#include "types.h"


class opt_cddoc : public QDialog
{
    Q_OBJECT

private:
    KSimpleConfig*    globalConf;
    T_FileOptions*    fileOpts;

public:
  /***** cdDoc **********/
  QLabel*       labelLatex;
  QLabel*       labelView;
  QLabel*       labelPrint;
  QLabel*       labelEdit;

  QLineEdit*  leView;
  QLineEdit*  lePrint;
  QLineEdit*  leLatex;
  QLineEdit*  leEdit; 

  opt_cddoc(QWidget*       parent,
	    const char*    name,
	    KSimpleConfig* globConf,
	    T_FileOptions  *sysOpts);
  ~opt_cddoc();
    

protected:
    /***** allgemein *********/
    QPushButton*   buttonCancel;
    QPushButton*   buttonApply;
    QPushButton*   buttonOK;
    /******* device ***********/

protected slots:
  void applySettings();
  void ok_clicked(); 
};

#endif // opt_cddoc_included






